#include <minigui.ch>

Function Main
local aData := {}
public dbo := nil
  
aData := initdata()  
define window s at 0,0 width 1024 height 768 title "Xtract Sample" main icon "cube"
   define grid data
      row 10
      col 10
      width 1000
      height 600
      items aData
      headers {"REGION","PRODUCT","SALESMAN","QUANTITY","DISCOUNT"}
      widths {150,150,150,150,150}
      justify {0,0,0,1,1}
   	COLUMNCONTROLS { {'TEXTBOX','CHARACTER'} , {'TEXTBOX','CHARACTER'} ,{'TEXTBOX','CHARACTER'},{'TEXTBOX','NUMERIC','999999'}  , {'TEXTBOX','NUMERIC','99'}} 
   end grid
   define button xtract
      row 620
      col 10
      width 80
      caption "Xtract"
      action dataxtract("s","data")
   end button
   define button csvexport
      row 620
      col 110
      width 80
      caption "Xport2CSV"
      action grid2csv("s","data",.t.)
   end button
   define button import
      row 620
      col 210
      width 80
      caption "DBF Import"
      action importfromdbf()
   end button
   define button close
      row 620
      col 310
      width 80
      caption "Close"
      action s.release()
   end button
end window
s.center
s.activate


Return

function dataxtract(cWindow,cGrid)
local aTypes := {}
local nItemCount := 0
local aLineData := {}
local i := nil
local aEditControls := {}
local aJustify := {}
private cWindowName := cWindow
private cGridName := cGrid
private aOperations := {"SUM","MINIMUM","MAXIMUM","COUNT"}
private aCols := {}



nItemCount := getproperty(cWindow,cGrid,"itemcount")
if nItemCount == 0
   return nil
endif
aLineData := getproperty(cWindow,cGrid,"item",1)
for nCount := 1 to len(aLineData)
   aadd(aCols,getproperty(cWindow,cGrid,"header",nCount))
   aadd(aTypes,valtype(aLineData[nCount]))
next nCount
i := GetControlIndex ( cGrid , cWindow )
aJustify := _HMG_SYSDATA [ 37 ] [i]

WAIT WINDOW "Creating Data Environment - Please wait..." NOWAIT
exporttosql("s","data")
wait clear 
   
define window xtract at 0,0 width 530 height 630 title "Xtract Window" modal 

   define label available
      row 10
      col 10
      width 200
      value "Available Columns"
   end label
   define listbox cols
      row 40
      col 10
      width 200
      height 150
      items aCols
      value 1
   end listbox
   define button addrow
      row 40
      col 220
      width 40
      caption "Row"
      fontbold .t.
      action addrow()
   end button
   define button addcol
      row 70
      col 220
      width 40
      fontbold .t.
      caption "Col"
      action addcol()
   end button
   define button adddata
      row 100
      col 220
      width 40
      fontbold .t.
      caption "Data"
      action adddata()
   end button
   define label operationslabel
      row 10
      col 270
      width 150
      value "Data Grouping Operations"
   end label
   define listbox operations
      row 40
      col 270
      width 150
      items aOperations
      value 1
      height 150
   end listbox
   define label selectedrowslabel
      row 200
      col 10
      width 200
      value "Row Grouping"
   end label
   define listbox selrows
      row 230
      col 10
      width 200
      height 150
   end listbox
   define button delrow
      row 230
      col 220
      width 40
      fontsize 30
      fontbold .t.
      caption "Del"
      action removerow()
   end button
   define button rowup
      row 270
      col 220
      width 40
      caption "Up"
      action rowup()
   end button
   define button rowdown
      row 310
      col 220
      width 40
      caption "Down"
      action rowdown()
   end button
   define label selectedcolslabel
      row 200
      col 270
      width 200
      value "Column Grouping"
   end label
   define listbox selcols
      row 230
      col 270
      width 200
      height 150
   end listbox
   define button delcol
      row 230
      col 480
      width 40
      fontsize 30
      fontbold .t.
      caption "Del"
      action removecol()
   end button
   define button colup
      row 270
      col 480
      width 40
      caption "Up"
      action colup()
   end button
   define button coldown
      row 310
      col 480
      width 40
      caption "Down"
      action coldown()
   end button
   define label datalabel
      row 410
      col 10
      width 200
      value "Selected Data & Operations"
   end label
   define grid datacols
      row 440
      col 10
      width 350
      headers {"Data","Operation"}
      widths {200,120}
      height 100
   end grid
   define button removedata
      row 440
      col 370
      width 40
      caption "Del"
      fontsize 30
      fontbold .t.
      action removedata()
   end button   
   define button dataup
      row 480
      col 370
      width 40
      caption "Up"
      action dataup()
   end button
   define button datadown
      row 520
      col 370
      width 40
      caption "Down"
      action datadown()
   end button
   define button report
      row 550
      col 10
      width 80
      caption "Report"
      action createreport()
   end button
   define button close
      row 550
      col 110
      width 80
      caption "Close"
      action xtract.release()
   end button
   define progressbar p1
      row 550
      col 210
      width 300
      rangemin 0
      rangemax 100
      value 0
   end progressbar
   define statusbar
      statusitem "Welcome"
   end statusbar
end window
xtract.p1.visible := .f.
xtract.center
xtract.activate

return nil

function addrow
local nValue := xtract.cols.value
if nValue > 0
   xtract.selrows.additem(xtract.cols.item(nValue))
   xtract.selrows.value := xtract.selrows.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function addcol
local nValue := xtract.cols.value
if nValue > 0
   xtract.selcols.additem(xtract.cols.item(nValue))
   xtract.selcols.value := xtract.selcols.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removerow
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.selrows.value
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aadd(aOld,xtract.selrows.item(nValue))
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.selrows.deleteitem(nValue)
   if xtract.selrows.itemcount > 0
      xtract.selrows.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removecol
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.selcols.value
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aadd(aOld,xtract.selcols.item(nValue))
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.selcols.deleteitem(nValue)
   if xtract.selcols.itemcount > 0
      xtract.selcols.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif

return nil

function adddata
local nValue := xtract.cols.value
local nOpValue := xtract.operations.value
if nValue > 0 .and. nOpValue > 0
   xtract.datacols.additem({xtract.cols.item(nValue),xtract.operations.item(nOpValue)})
   xtract.datacols.value := xtract.datacols.itemcount
   xtract.cols.deleteitem(nValue)
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif
return nil

function removedata
local aOld := {}
local aNew := {}
local i := 0
local nValue := xtract.datacols.value
local aLineData := {}
if nValue > 0
   for i := 1 to xtract.cols.itemcount
      aadd(aOld,xtract.cols.item(i))
   next i
   aLinedata := xtract.datacols.item(nValue)
   aadd(aOld,aLineData[1])
   for i := 1 to len(aCols)
      if ascan(aOld,aCols[i]) > 0
         aadd(aNew,aCols[i])
      endif
   next i
   xtract.datacols.deleteitem(nValue)
   if xtract.datacols.itemcount > 0
      xtract.datacols.value := 1
   endif
   xtract.cols.deleteallitems()
   for i := 1 to len(aNew)
      xtract.cols.additem(aNew[i])
   next i
   if xtract.cols.itemcount > 0
      xtract.cols.value := 1
   endif
endif

return nil

function rowup
local cOld := ""
local cNew := ""
local nValue := xtract.selrows.value
if nValue > 1
   cOld := xtract.selrows.item(nValue-1)
   cNew := xtract.selrows.item(nValue)
   xtract.selrows.item(nValue) := cOld
   xtract.selrows.item(nValue-1) := cNew
   xtract.selrows.value := nValue - 1
endif
return nil

function rowdown
local cOld := ""
local cNew := ""
local nValue := xtract.selrows.value
if nValue < xtract.selrows.itemcount
   cOld := xtract.selrows.item(nValue+1)
   cNew := xtract.selrows.item(nValue)
   xtract.selrows.item(nValue) := cOld
   xtract.selrows.item(nValue+1) := cNew
   xtract.selrows.value := nValue + 1
endif

return nil


function colup
local cOld := ""
local cNew := ""
local nValue := xtract.selcols.value
if nValue > 1
   cOld := xtract.selcols.item(nValue-1)
   cNew := xtract.selcols.item(nValue)
   xtract.selcols.item(nValue) := cOld
   xtract.selcols.item(nValue-1) := cNew
   xtract.selcols.value := nValue - 1
endif
return nil

function coldown
local cOld := ""
local cNew := ""
local nValue := xtract.selcols.value
if nValue < xtract.selcols.itemcount
   cOld := xtract.selcols.item(nValue+1)
   cNew := xtract.selcols.item(nValue)
   xtract.selcols.item(nValue) := cOld
   xtract.selcols.item(nValue+1) := cNew
   xtract.selcols.value := nValue + 1
endif
return nil

function dataup
local aOld := {}
local aNew := {}
local nValue := xtract.datacols.value
if nValue > 1
   aOld := xtract.datacols.item(nValue-1)
   aNew := xtract.datacols.item(nValue)
   xtract.datacols.item(nValue) := aOld
   xtract.datacols.item(nValue-1) := aNew
   xtract.datacols.value := nValue - 1
endif
return nil

function datadown
local aOld := {}
local aNew := {}
local nValue := xtract.datacols.value
if nValue < xtract.datacols.itemcount
   aOld := xtract.datacols.item(nValue+1)
   aNew := xtract.datacols.item(nValue)
   xtract.datacols.item(nValue) := aOld
   xtract.datacols.item(nValue+1) := aNew
   xtract.datacols.value := nValue + 1
endif

return nil



function createreport
local aRowIds := {}
local aColIds := {}
local aDataIds := {}
local aRowData := {}
local aColData := {}
local aData := {}
local aTable := {}
local aColTable := {}
local aResults := {}
local aLine := {}
local aCurRow := {}
local aCurCol := {}
local aCurData := {}
local aReportGrid := {}
local aColHead := {}
local aHeads := {}
local aFirstRow := {}
local aFirstCol := {}
local aFirstData := {}
local aResultLine := {}
local cQStr := ""
local cRowStr := ""
local cColStr := ""
local cDataStr := ""
local nRows := 0
local nCols := 0
local nData := 0
local nTotRows := 0
local nTotCols := 0
local i := 0
local j := 0
local aColTotal := {}
local aRowRotal := {}

wait window "Please wait while tabulating..." nowait


if xtract.selrows.itemcount > 0 .and. xtract.selcols.itemcount > 0 .and. xtract.datacols.itemcount == 0
   msgstop("You have to select a Data field if you select both Row and Col!")
   return nil
endif

if xtract.selrows.itemcount == 0 .and. xtract.selcols.itemcount == 0 .and. xtract.datacols.itemcount == 0
   msgstop("You have to select atleast a Row/Col Field and/or a Data Field!")
   return nil
endif

for i := 1 to xtract.selrows.itemcount
//   aadd(aRowIds,ascan(aCols,xtract.selrows.item(i)))
   aadd(aRowIds,xtract.selrows.item(i))
next i

for i := 1 to xtract.selcols.itemcount
//   aadd(aColIds,ascan(aCols,xtract.selcols.item(i)))
   aadd(aColIds,xtract.selcols.item(i))
next i

for i := 1 to xtract.datacols.itemcount
   aLineData := xtract.datacols.item(i)
//   aadd(aDataIds,{ascan(aCols,aLineData[1]),ascan(aOperations,aLineData[2])})
   aadd(aDataIds,{aLineData[1],aLineData[2]})
next i

//nItemCount := getproperty(cWindowName,cGridName,"itemcount")

nRows := len(aRowIds)
nCols := len(aColIds)
nData := len(aDataIds)

for i := 1 to nRows
   cRowStr := cRowStr + aRowIds[i]
   if i < nRows
      cRowStr := cRowStr + ","
   endif
next i

for i := 1 to nCols
   cColStr := cColStr + aColIds[i]
   if i < nCols
      cColStr := cColStr + ","
   endif
next i

for i := 1 to nData
   do case
      case aDataIds[i,2] == "SUM"
         cDataStr := cDataStr + "sum("+aDataIds[i,1]+")"
      case aDataIds[i,2] == "MINIMUM"
         cDataStr := cDataStr + "min(round("+aDataIds[i,1]+",5))"
      case aDataIds[i,2] == "MAXIMUM"
         cDataStr := cDataStr + "max(round("+aDataIds[i,1]+",5))"
      case aDataIds[i,2] == "COUNT"
         cDataStr := cDataStr + "count("+aDataIds[i,1]+")"
   endcase         
   if i < nData
      cDataStr := cDataStr + ","
   endif
next i

cQStr := "select "

if len(cRowStr) > 0
   cQStr := cQStr + cRowStr
   if len(cColStr) > 0 .or. len(cDataStr) > 0
      cQStr := cQStr + ","
   endif
endif

if len(cColStr) > 0
   cQStr := cQstr + cColStr
   if len(cDataStr) > 0
      cQstr := cQStr + ","
   endif
endif

if len(cDataStr) > 0
   cQStr := cQstr + cDataStr
endif

cQStr := cQStr + " from data"


if len(cRowStr) > 0 .or. len(cColStr) > 0
   cQStr := cQstr + " group by "
   
   if len(cRowStr) > 0
      cQStr := cQStr + cRowStr
      if len(cColStr) > 0
         cQStr := cQStr + ","
      endif
   endif
  
   if len(cColStr) > 0
      cQStr := cQstr + cColStr
   endif
 
   cQStr := cQStr + " order by "
  
   if len(cRowStr) > 0
      cQStr := cQStr + cRowStr
      if len(cColStr) > 0 
         cQStr := cQStr + ","
      endif
   endif

   if len(cColStr) > 0
      cQStr := cQstr + cColStr
   endif
endif

cStart := time()

aTable := sql(dbo,cQstr)

cTimeTaken := elaptime(cStart,time())
//msginfo("Query took "+substr(cTimeTaken,1,2)+" Hours, "+substr(cTimeTaken,4,2)+" Minutes, "+substr(cTimeTaken,7,2)+" Seconds.")

if len(cColStr) > 0

   cQStr := "select " + cColStr +" from data group by "+cColStr+" order by "+cColStr
   aColTable := sql(dbo,cQstr)
endif

asize(aResults,0)

nTotRows := len(aTable) * iif(nData > 0,nData,1)
nTotCols := nRows + iif(nData > 1,1,0)+len(aColTable)+iif(nCols == 0 .and. nData > 0,1,0)

//aResults := array(nTotRows,nTotCols)
nCurRow := 1

if nData <= 1
   aadd(aResults,array(nTotCols))
else
   for j := 1 to nData
      aadd(aResults,array(nTotCols))
   next j      
endif

asize(aFirstRow,0)
asize(aFirstCol,0)
asize(aFirstData,0)

aLine := aTable[1]
for j := 1 to nRows
   aadd(aFirstRow,aLine[j])
next j

for j := 1 to nCols
   aadd(aFirstCol,aLine[nRows+j])
next j

for j := 1 to nData
   aadd(aFirstData,aLine[nRows+nCols+j])
next j


for i := 1 to len(aFirstRow)
   aResults[nCurRow,i] := aFirstRow[i]
next i

if nCols > 0
   if nCols == 1
      nCurrent := ascan(aColTable,{|x|x[1] == aFirstCol[1]})
   else
      nCurrent := ascan(aColTable,{|x|comparearrays(x,aFirstCol)})
   endif
   if nData == 1
      aResults[nCurRow,nRows+nCurrent] := aFirstData[1]
   else
      aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
      aResults[nCurRow,nRows+1+nCurrent] := aFirstData[1]
      for j := 2 to nData
         aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
         aResults[nCurRow+j-1,nRows+1+nCurrent] := aFirstData[j]
      next j
   endif
else
   if nData > 0
      if nData == 1
         aResults[nCurRow,nRows+1] := aFirstData[1]
      else
         aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
         aResults[nCurRow,nRows+2] := aFirstData[1]
         for j := 2 to nData
            aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
            aResults[nCurRow+j-1,nRows+2] := aFirstData[j]
         next j
      endif
   endif
endif

for i := 2 to len(aTable)
   aLine := aTable[i]

   asize(aCurRow,0)
   asize(aCurCol,0)
   asize(aCurData,0)

   for j := 1 to nRows
      aadd(aCurRow,aLine[j])
   next j
 
   for j := 1 to nCols
      aadd(aCurCol,aLine[nRows+j])
   next j

   for j := 1 to nData
      aadd(aCurData,aLine[nRows+nCols+j])
   next j
   
   if comparearrays(aFirstRow,aCurRow) // Same Row different Column

      if nCols > 0
         if nCols == 1
            nCurrent := ascan(aColTable,{|x|x[1] == aCurCol[1]})
         else
            nCurrent := ascan(aColTable,{|x|comparearrays(x,aCurCol)})
         endif
         if nData == 1
            aResults[nCurRow,nRows+nCurrent] := aCurData[1]
         else
//            aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
            aResults[nCurRow,nRows+1+nCurrent] := aCurData[1]
            for j := 2 to nData
//               aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
               aResults[nCurRow+j-1,nRows+1+nCurrent] := aCurData[j]
            next j
         endif
      else
         if nData > 0
            if nData == 1
               aResults[nCurRow,nRows+1] := aCurData[1]
            else
//               aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
               aResults[nCurRow,nRows+2] := aCurData[1]
               for j := 2 to nData
//                  aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
                  aResults[nCurRow+j-1,nRows+2] := aCurData[j]
               next j
            endif
         endif
      endif
   else // new Row  of data
      if nData <= 1
         nCurRow := nCurRow + 1
         aadd(aResults,array(nTotCols))
      else
         nCurRow := nCurRow + nData
         for j := 1 to nData
            aadd(aResults,array(nTotCols))
   	     next j      
      endif
      lDiff := .f.
      for j := 1 to len(aFirstRow)
         if (.not. lDiff) .and. (aFirstRow[j] <> aCurRow[j])
            lDiff := .t.
         endif
         if lDiff
            aResults[nCurRow,j] := aCurRow[j]
         endif   
      next j
      
      aFirstRow := aclone(aCurRow)
      aFirstCol := aclone(aCurCol)
      aFirstData := aclone(aCurData)
      
      
      
      if nCols > 0
         if nCols == 1
            nCurrent := ascan(aColTable,{|x|x[1] == aFirstCol[1]})
         else
            nCurrent := ascan(aColTable,{|x|comparearrays(x,aFirstCol)})
         endif
         if nData == 1
            aResults[nCurRow,nRows+nCurrent] := aFirstData[1]
         else
            aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
            aResults[nCurRow,nRows+1+nCurrent] := aFirstData[1]
            for j := 2 to nData
               aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
               aResults[nCurRow+j-1,nRows+1+nCurrent] := aFirstData[j]
            next j
         endif
      else
         if nData > 0
            if nData == 1
               aResults[nCurRow,nRows+1] := aFirstData[1]
            else
               aResults[nCurRow,nRows+1] := aDataIds[1,2]+"-"+aDataIds[1,1]
               aResults[nCurRow,nRows+2] := aFirstData[1]
               for j := 2 to nData
                  aResults[nCurRow+j-1,nRows+1] := aDataIds[j,2]+"-"+aDataIds[j,1]
                  aResults[nCurRow+j-1,nRows+2] := aFirstData[j]
               next j
            endif
         endif
      endif
   endif
next i      

aColHead := {}
nCurRow := 1
if nCols > 0
   aadd(aColHead,array(nCols))
   aFirstRow := aclone(aColTable[1])
   aColHead[nCurRow] := aclone(aColTable[1])

   for i := 2 to len(aColTable)
      aadd(aColHead,array(nCols))
      nCurRow := nCurRow + 1
      lDiff := .f.
      aCurRow := aclone(aColTable[i])

      for j := 1 to nCols
         if (.not. lDiff) .and. (aFirstRow[j] <> aCurRow[j])
            lDiff := .t.
         endif
         if lDiff
            aColHead[nCurRow,j] := aCurRow[j]
         endif   
      next j
      aFirstRow := aclone(aCurRow)
   next i
endif

aHeaders := {}

if nRows > 0 .or. nCols > 0
   aadd(aHeaders,array(nTotCols))
   for i := 1 to nRows
      aHeaders[1,i] := aRowIds[i]
   next i
   for i := 1 to len(aColHead)
      aHeaders[1,nRows+iif(nData > 1,1,0)+i] := aColHead[i,1]
   next i
   if len(aColHead) > 0
      if len(aColHead[1]) > 1
         for i := 2 to len(aColHead[1])
            aadd(aHeaders,array(nTotCols))
            for j := 1 to len(aColHead)
               aHeaders[i,nRows+iif(nData > 1,1,0)+j] := aColHead[j,i]
            next j
         next i
      endif   
   endif   
endif         

//summation

if nCols > 0 .or. nData > 0
   aRowTotal := array(len(aResults))
   aColTotal := array(nData,len(aResults[1]))
   aGT := array(nData)
   
   nResRows := len(aResults)
   nResCols := len(aResults[1])
   
   for i := 1 to nResRows
      aRowTotal[i] := 0
   next i
   for i := 1 to nData
      for j := nRows+iif(nData > 1,1,0)+1 to nResCols
         aColTotal[i,j] := 0
      next j   
   next i
   for i := 1 to nData
      aGt[i] := 0
   next i
   
   for i := 1 to nResRows step nData
      for j := nRows+iif(nData > 1,1,0)+1 to nResCols
         for k := 0 to nData - 1
            do case
               case aDataIds[k+1,2] == "SUM" .or. aDataIds[k+1,2] == "COUNT"
                  aRowTotal[i+k] := aRowTotal[i+k] + iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),if(valtype(aResults[i+k,j]) == "U",0,aResults[i+k,j]))
                  aColTotal[k+1,j] := aColTotal[k+1,j] + iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),if(valtype(aResults[i+k,j]) == "U",0,aResults[i+k,j]))
                  aGT[k+1] := aGT[k+1] + iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),if(valtype(aResults[i+k,j]) == "U",0,aResults[i+k,j]))
               case aDataIds[k+1,2] == "MINIMUM" 
                  aRowTotal[i+k] := min(aRowTotal[i+k],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),iif(valtype(aResults[i+k,j])=="U",aRowTotal[i+k],aResults[i+k,j])))
                  aColTotal[k+1,j] := min(aColTotal[k+1,j],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),iif(valtype(aResults[i+k,j])=="U",aColTotal[k+1,j],aResults[i+k,j])))
                  aGT[k+1] := min(aGT[k+1],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),if(valtype(aResults[i+k,j]) == "U",aGT[k+1],aResults[i+k,j])))
               case aDataIds[k+1,2] == "MAXIMUM"   
                  aRowTotal[i+k] := max(aRowTotal[i+k],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),iif(valtype(aResults[i+k,j])=="U",aRowTotal[i+k],aResults[i+k,j])))
                  aColTotal[k+1,j] := max(aColTotal[k+1,j],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),iif(valtype(aResults[i+k,j])=="U",aColTotal[k+1,j],aResults[i+k,j])))
                  aGT[k+1] := max(aGT[k+1],iif(valtype(aResults[i+k,j]) == "C",val(alltrim(aResults[i+k,j])),if(valtype(aResults[i+k,j]) == "U",aGT[k+1],aResults[i+k,j])))
            endcase
         next k
      next j
   next i

   if nCols > 0
      for i := 1 to nResRows
         aadd(aResults[i],str(aRowTotal[i]))
      next i
   
      for i := 1 to nData
         aadd(aColTotal[i],aGT[i])
      next i
      
      aadd(aHeaders[1],"Total")
      for i := 2 to len(aHeaders)
         aadd(aHeaders[i],"")
      next i
   endif   

   if nData > 1 .or. nRows > 0 // there is room for "Total"
      aColTotal[1,1] := "Total"
   endif
      
   
   for i := 1 to nData
      for j := 1 to len(aColTotal[i])
         if valtype(aColTotal[i,j]) == "N"
            aColTotal[i,j] := alltrim(str(aColTotal[i,j]))
         endif   
      next j
   next i
      
   for i := 1 to nData
      aadd(aResults,aclone(aColTotal[i]))
   next i
   
   

endif




aReportGrid := {}

nHeaders := len(aHeaders)
if nHeaders > 0
   for i := 1 to nHeaders
      aadd(aReportGrid,aclone(aHeaders[i]))
   next i
endif

nResRows := len(aResults)
for i := 1 to nResRows
   aadd(aReportGrid,aclone(aResults[i]))
next i


wait clear 

//aReportGrid := aClone(aResults)

if len(aReportGrid) > 0
   aHeaders := {}
   aWidths := {}
   aJustify := {}
   for i := 1  to len(aReportGrid[1])
      aadd(aHeaders,'')
      aadd(aWidths,100)
      if i > 1 .and. i > nRows+iif(nData > 1,1,0)
         aadd(aJustify,1)
      else
         aadd(aJustify,0)
      endif   
   next i
   
   
   define window xtractreport at 0,0 width 1000 height 600 title "Xtract Report" modal nosize nosysmenu
      define grid data
         row 10
         col 10
         width 980
         height 500
         widths aWidths
         headers aHeaders
         justify aJustify
//         showheaders .f.
         items aReportGrid
      end grid
         
      define button close
         row 520
         col 10
         width 80
         caption "Close"
         action xtractreport.release()
      end button
   end window
   xtractreport.center
   xtractreport.activate

endif

return nil






function comparearrays(x,y)
local i,j := 0
local lenx,leny := 0
local xelement, yelement
if valtype(x) == "A" .and. valtype(y) == "A"
   lenx := len(x)
   leny := len(y)
   if lenx <> leny
      return .f.
   endif
   for i := 1 to lenx
      xelement := x[i]
      yelement := y[i]
      if valtype(xelement) <> valtype(yelement)
         return .f.
      else
         if valtype(xelement) == "A"
            if .not. comparearrays(xelement,yelement)
               return .f.
            endif
         else
            if xelement <> yelement
               return .f.
            endif
         endif
      endif
   next i
   return .t.
endif
return nil

function importfromdbf
local cDbfFileName := ""
local aStruct := {}
local aFieldNames := {}
local aFieldTypes := {}
local aWidths := {}
local aData := {}
local aCurRow := {}
local cCurFieldName := ""
local aJustify := {}
local i


cDbfFileName := Getfile ( { {'All DBF Files','*.dbf'} } , 'Open DBF File' , 'c:\' , .f. , .t. )
if len(alltrim(cDbfFileName)) > 0
   select a
   use &cDbfFileName
   aStruct := dbstruct()
   for i := 1 to len(aStruct)
      aadd(aFieldNames,aStruct[i,1])
      aadd(aFieldTypes,aStruct[i,2])
      aadd(aWidths,aStruct[i,3]*10)
      aadd(aJustify,iif(i == 1 .or. aStruct[i,2] == "C" .or. aStruct[i,2] == "D" .or. aStruct[i,2] == "L",0,1))
   next i
   go top
   do while .not. eof()
      for i := 1 to len(aFieldNames)
         cCurFieldName := aFieldNames[i]
         do case
            case aFieldTypes[i] == "C"
               aadd(aCurRow,a->&cCurFieldName)
            case aFieldTypes[i] == "N"                
               aadd(aCurRow,str(a->&cCurFieldName))
            case aFieldTypes[i] == "D"
               aadd(aCurRow,dtoc(a->&cCurFieldName))
            case aFieldTypes[i] == "L"
               aadd(aCurRow,iif(a->&cCurFieldName,"True","False"))
            otherwise
               aadd(aCurRow,a->&cCurFieldName)
         endcase
      next i
      aadd(aData,aclone(aCurRow))
      asize(aCurRow,0)
      select a
      skip
   enddo
   close all
   if iscontroldefined(data,s)
      s.data.release
   endif
   define grid data
      parent s
      row 10
      col 10
      width 1000
      height 600
      items aData
      headers aFieldNames
      widths aWidths
      justify aJustify
   end grid
endif
return nil


function exporttosql(cWindow,cGrid)
local aCols := {}
local aTypes := {}
local nItemCount := 0
local aLineData := {}
local nResult := 0
nItemCount := getproperty(cWindow,cGrid,"itemcount")
if nItemCount == 0
   return nil
endif
aLineData := getproperty(cWindow,cGrid,"item",1)
for nCount := 1 to len(aLineData)
   aadd(aCols,getproperty(cWindow,cGrid,"header",nCount))
   aadd(aTypes,valtype(aLineData[nCount]))
next nCount



connect2db("")

//connect2db("")

qstr := "drop table if exists data;"
if .not. miscsql(dbo,qstr)
   return nil
endif

qstr := "create table data ("
for i := 1 to len(aCols)
   qstr := qstr + aCols[i]
   if i < len(aCols)
      qstr := qstr + ","
   endif
next i
qstr := qstr + ");"

if .not. miscsql(dbo,qstr)
   return nil
endif
nRecCount := 0
nAtaTime := 100
cQstr := "BEGIN TRANSACTION;"   
for i := 1 to nItemCount
   if nRecCount >= nAtaTime
      cQstr := cQstr + "COMMIT;"
      if .not. miscsql(dbo,cQstr)
         return nil
      endif      
      nRecCount := 0
      cQstr := ""
      cQstr := "BEGIN TRANSACTION;"   
   endif
   cQstr := cQstr + "insert into data values ("
   aLineData := getproperty(cWindow,cGrid,"item",i)
   for j := 1 to len(aLineData)
      cQstr := cQstr + c2sql(aLineData[j])
      if j < len(aLineData)
         cQstr := cQstr + ","
      endif
   next j
   cQstr := cQstr + ");"
   nReccount := nRecCount + 1
next i
if nRecCount > 0
   cQstr := cQstr + "COMMIT;"
   if .not. miscsql(dbo,cQstr)
      return nil
   endif      
endif   

return nil


function initdata
local aData := {;
               {"EAST", "PRODUCT X","SALESMAN B",3570,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",9148,8 },;               
               {"EAST", "PRODUCT Y","SALESMAN A",2858,25},;
               {"WEST", "PRODUCT X","SALESMAN B",8059,15},;
               {"EAST", "PRODUCT Z","SALESMAN A",2972,24},;
               {"NORTH","PRODUCT X","SALESMAN A",1641,14},;
               {"EAST", "PRODUCT X","SALESMAN A",6046,20},;
               {"WEST", "PRODUCT Y","SALESMAN B",9190,19},;
               {"WEST", "PRODUCT X","SALESMAN A",1411,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",7113,7 },;
               {"SOUTH","PRODUCT X","SALESMAN A",4446,7 },;
               {"NORTH","PRODUCT Y","SALESMAN B",8027,3 },;
               {"EAST", "PRODUCT X","SALESMAN A",6352,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",1234,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",9329,15},;
               {"SOUTH","PRODUCT Y","SALESMAN A",7394,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",2917,12},;
               {"EAST", "PRODUCT Z","SALESMAN B",7373,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9886,23},;
               {"NORTH","PRODUCT X","SALESMAN A",1336,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",2631,22},;
               {"WEST", "PRODUCT X","SALESMAN A",5486,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9181,23},;
               {"EAST", "PRODUCT X","SALESMAN A",3374,12},;
               {"NORTH","PRODUCT X","SALESMAN B",9281,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8644,21},;
               {"SOUTH","PRODUCT X","SALESMAN A",7183,22},;
               {"WEST", "PRODUCT X","SALESMAN B",8544,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",3435,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",2619,18},;
               {"SOUTH","PRODUCT X","SALESMAN B",7648,20},;
               {"EAST", "PRODUCT Y","SALESMAN B",9870,12},;
               {"NORTH","PRODUCT Z","SALESMAN A",6641,9 },;
               {"EAST", "PRODUCT Z","SALESMAN A",6414,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4137,21},;
               {"EAST", "PRODUCT X","SALESMAN A",5439,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",2828,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",3168,21},;
               {"WEST", "PRODUCT Y","SALESMAN C",3950,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",8722,18},;
               {"NORTH","PRODUCT Z","SALESMAN A",2967,23},;
               {"EAST", "PRODUCT X","SALESMAN A",8312,3 },;
               {"SOUTH","PRODUCT X","SALESMAN C",9258,19},;
               {"EAST", "PRODUCT Y","SALESMAN A",7308,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3497,16},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",8123,17},;
               {"EAST", "PRODUCT Z","SALESMAN A",1594,5 },;
               {"NORTH","PRODUCT X","SALESMAN B",3666,23},;
               {"SOUTH","PRODUCT Y","SALESMAN A",9794,2 },;
               {"WEST", "PRODUCT X","SALESMAN A",7501,2 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9253,24},;
               {"SOUTH","PRODUCT X","SALESMAN A",6492,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2419,8 },;
               {"EAST", "PRODUCT Y","SALESMAN B",8987,25},;
               {"WEST", "PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Z","SALESMAN B",4604,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2820,14},;
               {"NORTH","PRODUCT X","SALESMAN B",6715,20},;
               {"EAST", "PRODUCT Y","SALESMAN A",8272,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4759,13},;
               {"WEST", "PRODUCT X","SALESMAN B",1678,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",5723,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",7854,3 },;
               {"SOUTH","PRODUCT X","SALESMAN B",3134,14},;
               {"EAST", "PRODUCT Y","SALESMAN B",9375,4 },;
               {"NORTH","PRODUCT Z","SALESMAN A",9622,15},;
               {"EAST", "PRODUCT Z","SALESMAN A",6820,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",5339,12},;
               {"EAST", "PRODUCT X","SALESMAN A",2159,6 },;
               {"WEST", "PRODUCT Y","SALESMAN A",6933,23},;
               {"EAST", "PRODUCT X","SALESMAN A",4318,12},;
               {"WEST", "PRODUCT Y","SALESMAN C",7311,22},;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"NORTH","PRODUCT Z","SALESMAN A",8377,23},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",9200,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",9993,21},;
               {"WEST", "PRODUCT X","SALESMAN A",3120,22},;
               {"EAST", "PRODUCT X","SALESMAN A",1870,13},;
               {"SOUTH","PRODUCT Z","SALESMAN A",1786,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",1358,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",9190,19},;
               {"WEST", "PRODUCT X","SALESMAN A",1411,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",7113,7 },;
               {"SOUTH","PRODUCT X","SALESMAN A",4446,7 },;
               {"NORTH","PRODUCT Y","SALESMAN B",8027,3 },;
               {"EAST", "PRODUCT X","SALESMAN A",6352,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",1234,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",9329,15},;
               {"SOUTH","PRODUCT Y","SALESMAN A",7394,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",2917,12},;
               {"EAST", "PRODUCT Z","SALESMAN B",7373,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9886,23},;
               {"NORTH","PRODUCT X","SALESMAN A",1336,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",2631,22},;
               {"WEST", "PRODUCT X","SALESMAN A",5486,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",9181,23},;
               {"EAST", "PRODUCT X","SALESMAN A",3374,12},;
               {"NORTH","PRODUCT X","SALESMAN B",9281,7 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8644,21},;
               {"SOUTH","PRODUCT X","SALESMAN A",7183,22},;
               {"WEST", "PRODUCT X","SALESMAN B",8544,13},;
               {"EAST", "PRODUCT Z","SALESMAN A",3435,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",2619,18},;
               {"SOUTH","PRODUCT X","SALESMAN B",7648,20},;
               {"EAST", "PRODUCT Y","SALESMAN B",9870,12},;
               {"NORTH","PRODUCT Z","SALESMAN A",6641,9 },;
               {"EAST", "PRODUCT Z","SALESMAN A",6414,19},;
               {"SOUTH","PRODUCT X","SALESMAN A",4137,21},;
               {"EAST", "PRODUCT X","SALESMAN A",5439,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",2828,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",3168,21},;
               {"WEST", "PRODUCT Y","SALESMAN C",3950,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",8722,18},;
               {"NORTH","PRODUCT Z","SALESMAN A",2967,23},;
               {"EAST", "PRODUCT X","SALESMAN A",8312,3 },;
               {"SOUTH","PRODUCT X","SALESMAN C",9258,19},;
               {"EAST", "PRODUCT Y","SALESMAN A",7308,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3497,16},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 },;
               {"EAST", "PRODUCT X","SALESMAN A",8272,15},;
               {"NORTH","PRODUCT X","SALESMAN B",4759,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1678,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",5723,6 },;
               {"WEST", "PRODUCT X","SALESMAN B",7854,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",3134,1 },;
               {"EAST", "PRODUCT X","SALESMAN A",9375,24},;
               {"SOUTH","PRODUCT X","SALESMAN B",9622,2 },;
               {"EAST", "PRODUCT Y","SALESMAN B",6820,25},;
               {"NORTH","PRODUCT Z","SALESMAN A",5339,2 },;
               {"EAST", "PRODUCT Z","SALESMAN A",2159,3 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6933,7 },;
               {"EAST", "PRODUCT X","SALESMAN A",4318,9 },;
               {"WEST", "PRODUCT Y","SALESMAN A",7311,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7589,8 },;
               {"WEST", "PRODUCT Y","SALESMAN C",8377,15},;
               {"EAST", "PRODUCT X","SALESMAN A",7489,13},;
               {"NORTH","PRODUCT Z","SALESMAN A",9200,20},;
               {"EAST", "PRODUCT X","SALESMAN A",9993,17},;
               {"SOUTH","PRODUCT X","SALESMAN C",3120,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",1870,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",1786,20},;
               {"EAST", "PRODUCT X","SALESMAN A",1358,7 },;
               {"SOUTH","PRODUCT Z","SALESMAN A",9741,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6616,10},;
               {"EAST", "PRODUCT X","SALESMAN B",4442,25},;
               {"WEST", "PRODUCT X","SALESMAN A",3544,15},;
               {"EAST", "PRODUCT Y","SALESMAN A",6207,20},;
               {"WEST", "PRODUCT X","SALESMAN B",6687,8 },;
               {"EAST", "PRODUCT Z","SALESMAN A",4199,1 },;
               {"NORTH","PRODUCT X","SALESMAN A",9234,18},;
               {"EAST", "PRODUCT X","SALESMAN A",4647,18},;
               {"WEST", "PRODUCT Y","SALESMAN B",8663,18},;
               {"WEST", "PRODUCT X","SALESMAN A",9919,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",9529,22},;
               {"SOUTH","PRODUCT X","SALESMAN A",1190,13},;
               {"NORTH","PRODUCT Y","SALESMAN B",3345,21},;
               {"EAST", "PRODUCT X","SALESMAN A",6414,23},;
               {"SOUTH","PRODUCT Z","SALESMAN A",5208,12},;
               {"EAST", "PRODUCT X","SALESMAN A",8700,18},;
               {"EAST", "PRODUCT X","SALESMAN B",7560,3 },;
               {"WEST", "PRODUCT X","SALESMAN A",5593,12},;
               {"EAST", "PRODUCT Y","SALESMAN A",9299,23},;
               {"WEST", "PRODUCT X","SALESMAN B",1332,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",3576,9 },;
               {"NORTH","PRODUCT X","SALESMAN A",3928,22},;
               {"EAST", "PRODUCT X","SALESMAN A",6787,13},;
               {"WEST", "PRODUCT Y","SALESMAN B",5463,12},;
               {"WEST", "PRODUCT X","SALESMAN A",7184,4 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8753,13},;
               {"SOUTH","PRODUCT X","SALESMAN A",6419,24},;
               {"NORTH","PRODUCT Y","SALESMAN B",6105,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",7085,19},;
               {"EAST", "PRODUCT Z","SALESMAN A",2252,22},;
               {"NORTH","PRODUCT X","SALESMAN B",5270,18},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5639,22},;
               {"WEST", "PRODUCT X","SALESMAN A",1817,10},;
               {"EAST", "PRODUCT Z","SALESMAN B",3265,6 },;
               {"SOUTH","PRODUCT X","SALESMAN A",6963,22},;
               {"NORTH","PRODUCT X","SALESMAN A",6278,10},;
               {"EAST", "PRODUCT Y","SALESMAN B",3993,14},;
               {"WEST", "PRODUCT X","SALESMAN A",1696,8 },;
               {"EAST", "PRODUCT Z","SALESMAN B",8057,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",7033,10},;
               {"NORTH","PRODUCT X","SALESMAN B",1032,22},;
               {"EAST", "PRODUCT Y","SALESMAN A",5447,25},;
               {"SOUTH","PRODUCT X","SALESMAN A",6878,11},;
               {"WEST", "PRODUCT X","SALESMAN B",5332,22},;
               {"EAST", "PRODUCT Z","SALESMAN A",9915,10},;
               {"EAST", "PRODUCT X","SALESMAN A",3267,13},;
               {"SOUTH","PRODUCT X","SALESMAN B",3585,12},;
               {"EAST", "PRODUCT Y","SALESMAN B",6959,19},;
               {"NORTH","PRODUCT Z","SALESMAN A",8001,18},;
               {"EAST", "PRODUCT Z","SALESMAN A",2444,1 },;
               {"SOUTH","PRODUCT X","SALESMAN A",9743,14},;
               {"EAST", "PRODUCT X","SALESMAN A",7465,17},;
               {"WEST", "PRODUCT Y","SALESMAN A",3424,25},;
               {"EAST", "PRODUCT X","SALESMAN A",7717,6 },;
               {"WEST", "PRODUCT Y","SALESMAN C",9181,14},;
               {"EAST", "PRODUCT X","SALESMAN A",2697,22},;
               {"NORTH","PRODUCT Z","SALESMAN A",9121,19},;
               {"EAST", "PRODUCT X","SALESMAN A",1347,12},;
               {"SOUTH","PRODUCT X","SALESMAN C",5434,17},;
               {"EAST", "PRODUCT Y","SALESMAN A",9621,1 },;
               {"WEST", "PRODUCT X","SALESMAN A",3995,2 },;
               {"EAST", "PRODUCT X","SALESMAN A",6721,14},;
               {"SOUTH","PRODUCT Z","SALESMAN A",7527,24},;
               {"EAST", "PRODUCT X","SALESMAN A",2076,22},;
               {"EAST", "PRODUCT X","SALESMAN B",5273,5 },;
               {"WEST", "PRODUCT X","SALESMAN A",7427,9 },;
               {"EAST", "PRODUCT Y","SALESMAN A",8404,15},;
               {"WEST", "PRODUCT X","SALESMAN B",3628,14},;
               {"EAST", "PRODUCT Z","SALESMAN A",2569,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",2176,9 },;
               {"EAST", "PRODUCT X","SALESMAN A",5764,21},;
               {"WEST", "PRODUCT Y","SALESMAN B",8177,4 },;
               {"WEST", "PRODUCT X","SALESMAN A",3695,16},;
               {"EAST", "PRODUCT Z","SALESMAN A",3501,20},;
               {"SOUTH","PRODUCT X","SALESMAN A",2599,4 },;
               {"NORTH","PRODUCT Y","SALESMAN B",6468,19},;
               {"EAST", "PRODUCT X","SALESMAN A",5747,7 },;
               {"EAST", "PRODUCT Z","SALESMAN A",8627,18},;
               {"NORTH","PRODUCT X","SALESMAN B",1211,13},;
               {"SOUTH","PRODUCT Y","SALESMAN A",5171,19},;
               {"WEST", "PRODUCT X","SALESMAN A",6492,24},;
               {"EAST", "PRODUCT Z","SALESMAN B",2419,4 },;
               {"SOUTH","PRODUCT X","SALESMAN A",8987,3 },;
               {"NORTH","PRODUCT X","SALESMAN A",1676,15},;
               {"EAST", "PRODUCT Y","SALESMAN B",4604,8 },;
               {"WEST", "PRODUCT X","SALESMAN A",2820,19},;
               {"EAST", "PRODUCT Z","SALESMAN B",6715,4 };
            }
return aclone(aData)


FUNCTION connect2db(dbname)
dbo := sqlite3_open( dbname,.t.)
IF Empty( dbo )
   msginfo("Database could not be connected!")
   RETURN nil
ENDIF

//msginfo("Successfully Connected to the MySQL Server",appname)
RETURN nil

function sql(dbo1,qstr)   
local table := {}
local currow := nil
local tablearr := {}
local rowarr := {}
local datetypearr := {}
local numtypearr := {}
local typesarr := {}
local current := ""
local i := 0
local j := 0
local type1 := ""
table := sqlite3_get_table(dbo1,qstr)
if sqlite3_errcode(dbo1) > 0 // error
   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
   return nil
endif 
stmt := sqlite3_prepare(dbo1,qstr)
IF ! Empty( stmt )
   for i := 1 to sqlite3_column_count( stmt )
      type1 := sqlite3_column_decltype( stmt,i)
      do case
         case type1 == "TEXT"
            aadd(typesarr,"C")
         case type1 == "INTEGER" .or. type1 == "REAL"
            aadd(typesarr,"N")
         otherwise
            aadd(typesarr,"C")   
      endcase
   next i
endif
sqlite3_reset( stmt )
   
if len(table) > 1
   asize(tablearr,0)
   rowarr := table[2]
   for i := 1 to len(rowarr)
      current := rowarr[i]
/*      if typesarr[i] == "C" .and. len(alltrim(current)) == 10 .and. val(alltrim(substr(current,1,4))) > 0 .and. val(alltrim(substr(current,6,2))) > 0 .and. val(alltrim(substr(current,6,2))) <= 12 .and. val(alltrim(substr(current,9,2))) > 0 .and. val(alltrim(substr(current,9,2))) <= 31 .and. substr(alltrim(current),5,1) == "-" .and. substr(alltrim(current),8,1) == "-" 
         aadd(datetypearr,.t.)
      else
      */
         aadd(datetypearr,.f.)
/*      endif*/
   next i
   for i := 2 to len(table)
      rowarr := table[i]
      for j := 1 to len(rowarr)
         if datetypearr[j]
            rowarr[j] := CToD(SubStr(alltrim(rowarr[j]),9,2)+"-"+SubStr(alltrim(rowarr[j]),6,2)+"-"+SubStr(alltrim(rowarr[j]),1,4))
         endif
         if typesarr[j] == "N"
            rowarr[j] := val(rowarr[j])
         endif    
      next j
      aadd(tablearr,aclone(rowarr))
   next i
endif
return tablearr

function miscsql(dbo1,qstr)
if empty(dbo1)
   msgstop("Database Connection Error!")
   return .f.
endif
sqlite3_exec(dbo1,qstr)
if sqlite3_errcode(dbo1) > 0 // error
   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
   return .f.
endif 
return .t.

function C2SQL(Value)

   local cValue := ""
   local cdate := ""
   if valtype(value) == "C" .and. len(alltrim(value)) > 0
      value := strtran(value,"'","''")
   endif   
   do case
      case Valtype(Value) == "N"
         cValue := "'"+AllTrim(Str(Value))+"'"

      case Valtype(Value) == "D"
         if !Empty(Value)
            cdate := dtos(value)
            cValue := "'"+substr(cDate,1,4)+"-"+substr(cDate,5,2)+"-"+substr(cDate,7,2)+"'"
         else
            cValue := "''"
         endif
      case Valtype(Value) $ "CM"
         IF Empty( Value)
            cValue="''"
         ELSE
            cValue := "'" + value + "'"
         ENDIF

      case Valtype(Value) == "L"
         cValue := AllTrim(Str(iif(Value == .F., 0, 1)))

      otherwise
         cValue := "''"       // NOTE: Here we lose values we cannot convert

   endcase
return cValue
